;*******************************************************************************
;* Digitlis technika 10. laboratrium                                         *
;* Knight Rider futfny szoftveres s hardveres idztssel.                  *
;*******************************************************************************
DEF LD  0x80                ; LED adatregiszter            (rhat/olvashat)
DEF TR  0x82                ; Timer kezdllapot regiszter (csak rhat)
DEF TM  0x82                ; Timer szmll regiszter     (csak olvashat)
DEF TC  0x83                ; Timer parancs regiszter      (csak rhat)
DEF TS  0x83                ; Timer sttusz regiszter      (csak olvashat)


;*******************************************************************************
;* A program kezdete. A programmemria 0x00 s a 0x01 cme a reset, illetve    *
;* a megszakts vektor. Ide ugr utastsokat kell elhelyezni, amelyek a      *
;* megfelel programrszre ugranak. Ha nem hasznlunk megszaktst, akkor a    *
;* program kezddhet a 0x00 cmen is.                                          *
;*******************************************************************************
start:
    
shr_loop:                   ;Ciklus a jobbra lptetshez.

shl_loop:                   ;Ciklus a balra lptetshez.


;*******************************************************************************
;* Szoftveres idztsi szubrutin. 24 bites ciklusvltozt kell hasznlnunk,   *
;* melyet nullrl indtva s egyesvel nvelve kb. 12,58 msodpercig fog      *
;* futni a szubrutin. Teht a kvnt 0,25 msodperces vrakozshoz a ciklus-   *
;* vltozt 50-nel kell nvelni.                                               *
;*******************************************************************************
sw_wait:

    rts                     ;Visszatrs a hvhoz.
    

;*******************************************************************************
;* A timer perifrit inicializl szubrutin. Ismtldses mkdsi mdot kell *
;* belltani. Ha elosztsnak 65536-ot vlasztunk, akkor az idzt szmll  *
;* kezdrtke 60 kell, hogy legyen a 0,25 msodperces idztsi peridushoz.  *
;* (60 + 1) * 65536 * 62,5 ns ~ 0,25 s                                         *
;*******************************************************************************
tmr_init:

    rts                     ;Visszatrs a hvhoz.

    
;*******************************************************************************
;* Hardveres idztsi szubrutin. A timer perifria sttusz regiszterben a    *
;* TOUT bit (bit 2) jelzi az idztsi peridus vgt, erre kell vrakoznunk.  *
;* A sttusz regiszter olvassa automatikusan trli a TOUT bitet.              *
;*******************************************************************************
tmr_wait:

    rts                     ;Visszatts a hvhoz.
    
